{+--------------------------------------------------------------------------+
 | Created:     05.98
 | Author:      Martin Waldenburg
 | Copyright    1998, all rights reserved.
 | Description: Demo for TmwCustomComboEdit
 | DISCLAIMER:  This is provided as is, expressly without a warranty of any kind.
 |              You use it at your own risc.
 +--------------------------------------------------------------------------+}
unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls;

type
  TForm2 = class(TForm)
    TreeView1: TTreeView;
    ImageList1: TImageList;
    ImageList2: TImageList;
    procedure TreeView1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TreeView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
  public
    function MouseInControl(X, Y: Integer): Boolean;
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

uses Unit1;

procedure TForm2.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do
  begin
    ExStyle := WS_EX_TOOLWINDOW or WS_EX_TOPMOST;
    WindowClass.Style := CS_SAVEBITS;
  end;
end; { CreateParams }

procedure TForm2.CreateWnd;
begin
  inherited CreateWnd;
  Windows.SetParent(Handle, 0); CallWindowProc(DefWndProc, Handle, wm_SetFocus, 0, 0);
end; { CreateWnd }

function TForm2.MouseInControl(X, Y: Integer): Boolean;
begin
  Result := True;
  if (X < TreeView1.Left + 1) or (X > TreeView1.Left + TreeView1.Width - 1) then Result := False;
  if (Y < TreeView1.Top + 1) or (Y > TreeView1.Top + TreeView1.Height - 1) then Result := False;
  if Result then ReleaseCapture else SetCaptureControl(TreeView1);
end; { MouseInControl }

procedure TForm2.TreeView1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  TreeHitTest: THitTests;
begin
  begin
    TreeHitTest := TreeView1.GetHitTestInfoAt(X, Y);
    if (htOnItem in TreeHitTest) or (htOnRight in TreeHitTest) then
      TreeView1.Selected := TreeView1.GetNodeAt(X, Y);
  end;
  inherited;
end;

procedure TForm2.TreeView1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  HitTest: THitTests;
  BitMapOne: TBitMap;
  BitMapTwo: TBitMap;
begin
  if Button = mbLeft then
    Case MouseInControl(X, Y) of
      True:
        begin
          SendMessage((Owner as TWinControl).Handle, WM_LBUTTONDOWN, 0, 0);
          HitTest := TreeView1.GetHitTestInfoAt(X, Y);
          if (htOnItem in HitTest) or (htOnRight in HitTest) then
          begin
            BitMapOne := TBitMap.Create;
            BitMapTwo := TBitMap.Create;
            TreeView1.Selected.EndEdit(True);
            Form1.mwCustomComboEdit1.Text := TreeView1.Selected.Text;
            ImageList1.GetBitMap(TreeView1.Selected.ImageIndex, BitMapOne);
            Form1.mwCustomComboEdit1.Image := BitMapOne;
            ImageList2.GetBitMap(TreeView1.Selected.StateIndex, BitMapTwo);
            Form1.mwCustomComboEdit1.StateImage := BitMapTwo;
            Enabled := False;
            Visible := False;
            BitMapOne.Free;
            BitMapTwo.Free;
          end;
        end;
      False:
        begin
          ReleaseCapture;
          Enabled := False;
          Visible := False;
        end;
    else SendMessage((Owner as TWinControl).Handle, WM_LBUTTONDOWN, 0, 0);
    end;
  inherited;
end;

end.

